#ifndef MPEG2TS_H
#define MPEG2TS_H

#define TSPKT_SIZE      188UL       // TSpPbg̃oCg
#define TSDATA_SIZE     184UL       // TSpPbg̃wb_oCg
#define MAX_PID         0x2000UL    // PIDől
#define MAX_DSC_LEN     0x100UL     // Descriptor̍ő咷
#define MAX_PSI_LEN     0x1000UL    // PSI̍ő咷

// TSwb_ 4BYTE
typedef union TS_HDR_u {
    unsigned long dword0;
    struct {
        unsigned long continuity_counter           :  4;
        unsigned long adaptation_field_control     :  2;
        unsigned long transport_scrambling_control :  2;
        unsigned long PID                          : 13;
        unsigned long transport_priority           :  1;
        unsigned long payload_unit_start_indicator :  1;
        unsigned long transport_error_indicator    :  1;
        unsigned long sync_byte                    :  8;
    };
} TsHdr_t;

// PSIwb_ 3BYTE + _~[ 1BYTE
typedef union PSI_HDR_u {
    unsigned long dword0;
    struct {
        unsigned long dummy                    :  8;
        unsigned long private_section_length   : 12;
        unsigned long reserved                 :  2;
        unsigned long private_indicator        :  1;
        unsigned long section_syntax_indicator :  1;
        unsigned long table_id                 :  8;
    };
} PsiHdr_t;

// PSIgwb_ 5BYTE
typedef struct PSI_EX_HDR_s {
    union {
        unsigned long dword0;
        struct {
            unsigned long section_number         :  8;
            unsigned long current_next_indicator :  1;
            unsigned long version_number         :  5;
            unsigned long reserved               :  2;
            unsigned long table_id_extension     : 16;
        };
    };
    unsigned char last_section_number;
} PsiExHdr_t;

#endif // MPEG2TS_H
